*cfr_analysis_final_pt5.do
*By Jesse Rothstein
*7/28/2014
*
*Part 5 of a series of programs, based on CFRs analysis_final.do 
*(April 2014 version).
*
***********************************************************************


version 12
matrix drop _all
estimates clear
set varabbrev off /*JR added*/

cap project, doinfo
if _rc==0 {
	local doasproject=1
	local pdir "`r(pdir)'"						  	    // the project's main dir.
	local dofile "`r(dofile)'"						    // do-file's stub name
  local sig {bind:{hi:[RP : `dofile'.do]}}	// a signature in notes

}
else {
  local doasproject=0
	local pdir "~/teachereffects/cfr_replic/project"
	local dofile "cfr_analysis_final_pt5"
	local sig "Not run as part of project!"
	
}
local thisdir "`pdir'/cfr"

*******************************************
****** SETUP CODE BLOCK - ALWAYS RUN ******
*******************************************

*global datadir "`cfrdat'" /*JR orig: global datadir $root/datadir */
*JR orig: global IRSdir ${datadir}/from_IRS
if `doasproject'==1 project, relies_on(`thisdir'/cfr_analysis_final_setup.do)
include `thisdir'/cfr_analysis_final_setup.do

if `doasproject'==1 {
  project, uses(`cfrdat'/schd_work_trim.dta)
  project, uses(`cfrdat'/tfx/score_r.dta)
  project, uses(`cfrdat'/tfx/tfx_tym.dta)
}


***************************START OF CFR PROGRAM********************************
******************BASED ON LINES 815-1200 OF ANALYSIS_FINAL.DO*****************


*~*~*~*~*~*~*~*~*~**~*~*~*~*~*~*~
*~*~*~*~*~* PAPER 1 *~*~*~*~*~*~*
*~*~*~*~*~*~*~*~*~**~*~*~*~*~*~*~

*******************
***** Table 1 *****
*******************
* JR added:  Comment out all of Table 1
* Table 1 is generated at the IRS, except for the t_exp_reg & CLass_size rows.

****** Read in data from IRS log
*
** Count number of lines in IRS log, set number of obs to number of lines
*file open irslog using "${datadir}/from_IRS/summary_stats_${summstats_date}.lst", read
*file read irslog line
*local lines=1
*while (r(eof)==0) {
*	file read irslog line
*	local ++lines
*}
*file close irslog
*
*clear
*set obs `lines'
*
** Create vars
*gen str var=""
*gen float mean=.
*gen float sd=.
*gen long n=.
*gen byte paper=.
*
*local varnum=0
*local papernum=1
*local blocknum=1
*
** Process IRS log
*file open irslog using "${datadir}/from_IRS/summary_stats_${summstats_date}.lst", read
*file read irslog line
*
*set more off
*while (r(eof)==0) {
*	tokenize ""
*	
*	* find heading 'Variable' at beginning of line, or end of a section
*	while ("`1' `2' `3' `4'"!="Variable Label N Mean") & ("`1' `2' `3'"!="Variable N Mean") & !inlist(trim(`"`line'"'),"Analysis Variable : par_age_birth","Analysis Variable : count_paper1","Analysis Variable : count_paper2") {
*		file read irslog line
*		tokenize `"`line'"'
*	}
*	
*	if (trim(`"`line'"')=="Analysis Variable : par_age_birth") {
*		* augment block counter
*		local ++blocknum
*	
*		* find top of table
*		while (substr(trim(`"`line'"'),1,1)!="-") {
*			file read irslog line
*		}
*		
*		* read in summary stats
*		local ++varnum
*		file read irslog line
*		qui replace var="par_age_birth_block`blocknum'" in `varnum'
*		qui replace n=real(word(`"`line'"',-5)) in `varnum'
*		qui replace mean=real(word(`"`line'"',-4)) in `varnum'
*		qui replace sd=real(word(`"`line'"',-3)) in `varnum'
*		qui replace paper=`papernum' in `varnum'
*		
*		* restart loop
*		continue
*	}
*	
*	if (trim(`"`line'"')=="Analysis Variable : count_paper1") {
*		* find top of "count_paper1" table
*		while (substr(trim(`"`line'"'),1,1)!="-") {
*			file read irslog line
*		}
*		
*		* read in count_paper1 summary stats: Number of subject-school years per student
*		local ++varnum
*		file read irslog line
*		qui replace var="count_paper1" in `varnum'
*		qui replace n=real(word(`"`line'"',-5)) in `varnum'
*		qui replace mean=real(word(`"`line'"',-4)) in `varnum'
*		qui replace sd=real(word(`"`line'"',-3)) in `varnum'
*		qui replace paper=`papernum' in `varnum'
*		
*		* increment paper counter
*		local blocknum=1
*		local papernum=2
*		
*		* restart loop
*		continue
*	}
*	
*	if (trim(`"`line'"')=="Analysis Variable : count_paper2") {
*		* find top of "count_paper2" table
*		while (substr(trim(`"`line'"'),1,1)!="-") {
*			file read irslog line
*		}
*		
*		* read in count_paper2 summary stats: Number of subject-school years per student
*		local ++varnum
*		file read irslog line
*		qui replace var="count_paper2" in `varnum'
*		qui replace n=real(word(`"`line'"',-5)) in `varnum'
*		qui replace mean=real(word(`"`line'"',-4)) in `varnum'
*		qui replace sd=real(word(`"`line'"',-3)) in `varnum'
*		qui replace paper=`papernum' in `varnum'	
*	
*		* exit loop
*		continue, break
*	}
*	
*	* If "Variable" isn't at the front of the line, augment block counter
*	if (ltrim(`"`line'"')!=`"`line'"') local ++blocknum
*
*	* advance 2 lines to first summary stats
*	file read irslog line
*	file read irslog line
*	
*	* continue until hit end of page, marked by "-------"
*	while (substr(trim(`"`line'"'),1,1)!="-") {
*		local ++varnum
*		if (`blocknum'==1) qui replace var=word(`"`line'"',1) in `varnum'
*		else qui replace var=word(`"`line'"',1)+"_block`blocknum'" in `varnum'
*		qui replace n=real(word(`"`line'"',-5)) in `varnum'
*		qui replace mean=real(word(`"`line'"',-4)) in `varnum'
*		qui replace sd=real(word(`"`line'"',-3)) in `varnum'
*		qui replace paper=`papernum' in `varnum'
*		
*		file read irslog line
*	}
*}
*file close irslog
*
*drop if missing(var)
*
*save ${datadir}/summary_stats_from_IRS_${summstats_date}.dta, replace
*
****** Output csv for Paper 1
*
** Compute summary stats for t_exp_reg and CLass_size on the outside
*use ${datadir}/analysis_irsdate${IRSdate}_tfxdate${tfxdate}.dta, clear
*
*sum t_exp_reg [w=CLass_size]
*scalar __texp_mean=r(mean)
*scalar __texp_sd=r(sd)
*scalar __texp_n=r(sum_w)
*
*sum CLass_size
*scalar __classsize_mean=r(mean)
*scalar __classsize_sd=r(sd)
*scalar __classsize_n=r(N)
*
** Save to a new dataset
*clear
*set obs 2
*
*gen str20 var=""
*gen float mean=.
*gen float sd=.
*gen long n=.
*gen byte paper=1
*
*replace var="t_exp_reg" in 1
*replace mean=__texp_mean in 1
*replace sd=__texp_sd in 1
*replace n=__texp_n in 1
*
*replace var="CLass_size_classweighted" in 2
*replace mean=__classsize_mean in 2
*replace sd=__classsize_sd in 2
*replace n=__classsize_n in 2
*
** Append IRS summary stats data
*append using ${datadir}/summary_stats_from_IRS_${summstats_date}.dta
*keep if paper==1
*
** Change the denominator on the fraction of obs with parents missing:
** --> report the fraction obs with parents missing out of the total, rather than out of those matched to tax data
*list if var=="par_missing"
*sum n if var=="CLass_size"
*replace mean=((mean*n)+(r(mean)-n))/r(mean) if var=="par_missing"
*replace sd=. if var=="par_missing"
*replace n=r(mean) if var=="par_missing"
*list if var=="par_missing"
*
** Rename the "blockN" summary stats
*drop if inlist(var,"lunch_block2","miss_lunch_block2")
*drop if inlist(var,"lunch_block3","lunch_orig_block3","miss_lunch_orig_block3")
*drop if var=="par_age_birth_block4"
*replace var=subinstr(var,"_block4","_subsample",.)
*replace var=subinstr(var,"_block5","_subsample",.)
*drop if var=="par_age_birth_block6"
*replace var=subinstr(var,"_block7","_subsample",.)
*
** Output
*outsheet using ${tab}/paper1/table1_summstatsdate${summstats_date}.csv, comma replace


***** A few summary stats are generated here to be sent to the IRS to check that they match.

log using `logdir'/paper1_table1_summarystats_fromoutside.txt, text replace

use `cfrdat'/schd_work_trim.dta, clear

* Generate minority dummy (black or hispanic)
g minority = CLETHNethnici_3+CLETHNethnici_4

* Mark the sample that was used to compute VA
mark VAsample
*JR orig: markout VAsample teacher year middle math score ${baseline_VAM_controls}
markout VAsample teacher year math score ${baseline_VAM_controls}

* Compute summary stats at the indiviudal-level
sum score if VAsample
sum female if VAsample 
sum minority if VAsample

* Compute class size summary stat
preserve
collapse (sum) class_size=VAsample, by(sch year class_id math)
sum class_size if class_size>0
restore

* Compute "# of subject-school-years per student" summary stat
collapse (max) VAsample, by(sch year math stuid)
collapse (sum) n_subject_sch_yr=VAsample, by(stuid)
sum n_subject_sch_yr if n_subject_sch_yr>0

log close

*******************
***** Table 2 *****
*******************

* see above in "VALUE-ADDED ESTIMATION" section.
* --> code is up there because the results of the quadratic fit are used for the generation of tv_sd in the "CROSS-CLASS ANALYSIS DATA SETUP" section.



*******************
***** Table 3 *****
*******************

*** Table 3, Col 1
use `cfrdat'/tfx/score_r, clear
*gen middle_math=middle*math

* Merge in tv from the _tym file so that the sample matches correctly
drop tv
merge m:1 teacher year math using `cfrdat'/tfx/tfx_tym.dta, assert(3) nogen keepusing(tv)

estimates clear
*JR orig: reg score_r tv middle math middle_math, cluster(sch_cohort)
reg score_r tv math , cluster(sch_cohort)
estimates store col1

*esttab col* using `tabdir'/paper1/table3_col1.csv, replace keep(tv) cells(b(fmt(%12.0g)) se(abs par fmt(%12.0g))) obslast
*estimates clear

* Figure 2a (corresponds to Col 1)
*binscatter score_r tv, noaddmean controls(middle math middle_math)
binscatter score_r tv, noaddmean controls(math ) ///
	xscale(range(-.2 0.23)) ///
	yscale(range(-.2 0.235)) ///
	legend(off) ylabel(,angle(horizontal)) ///
	title("Actual Score", size(medium)) ///
	xtitle("Teacher Value-Added") ///
	ytitle("Score in Year t") /// 
	ylabel(-0.2(0.1)0.2, angle(0))
multi_graph_export using `figdir'/paper1/fig2a


*JR Note: Column 2 of CFR's code uses "diff_score_rminuspar", which is not
*         created in the code CFR released. The notes to Figure 2 indicate
*         that it is created much the same way that A is from A* (consistent 
*         with Column 1 above). I'll take that approach here, but use the
*         unadjusted prediction based on parental education as an alternate
*         specification below. Code in this section is more heavily modified
*         from CFR's original than elsewhere.

*** Table 3, Cols 2-3
*use ${datadir}/analysis_irsdate${IRSdate}_tfxdate${tfxdate}.dta, clear

*JR addition: Do the first-stage regression to residualize predscore_pared.
*             This needs to go back to the microdata, then aggregate again 
*             and merge to the analysis file;
 use stuid year math d_pared2-d_pared7 using `cfrdat'/NOTIRS_studentlevel.dta, clear
 merge 1:1 stuid year math using `cfrdat'/tfx/score_r, keep(1 3) nogen
 merge 1:1 stuid year math using `cfrdat'/schd_work_trim, keep(1 3) nogen
 foreach f of varlist d_pared? {
 	 gen d`f'=.
   forvalues m=0/1 {
 	   qui areg `f' $baseline_VAM_controls if math==`m', absorb(teacher)
  	 tempvar pred
  	 predict `pred', dresiduals
 	   replace d`f'=`pred' if math==`m' & e(sample)
  	 drop `pred'
   }
 }
 reg score_r dd_pared? math
 predict diff_predscore_pared, xb
 collapse (mean) diff_predscore_pared (count) diff_predscore_count=diff_predscore_pared, by(sch year class_id math)
 merge 1:1 sch year class_id math using `cfrdat'/analysis
*End of JR addition. 	 

** Col 2
*reg diff_score_rminuspar tv middle math middle_math [w=diff_score_rminuspar_count], cluster(sch_cohort)
reg diff_predscore_pared tv math [w=diff_predscore_count], cluster(sch_cohort)
estimates store col2

*sum diff_score_rminuspar [w=diff_score_rminuspar_count] if e(sample)
su diff_predscore_pared [w=diff_predscore_count] if e(sample)
local col2_individuals=`r(sum_w)'
 
* Figure 2b (corresponds to Col 2)
*binscatter diff_score_rminuspar tv [aw=diff_score_rminuspar_count], noaddmean controls(middle math middle_math) 
binscatter diff_predscore_pared tv [aw=diff_predscore_count], noaddmean controls(math ) ///
	xscale(range(-.2 0.23)) ///
	yscale(range(-.2 0.235)) ///
	legend(off) ylabel(,angle(horizontal)) ///
	title("Predicted Score using Parent Characteristics", size(medium)) ///
	xtitle("Teacher Value-Added") ///
	ytitle("Predicted Score") /// 
 	ylabel(-0.2(0.1)0.2, angle(0))
multi_graph_export using `figdir'/paper1/fig2b

*JR: 
*JR: * Col 3
*JR NOTE: This is described in the table as "with controls," but they aren't here. Huh?
*JR: reg score_r_withpar tv middle math middle_math [w=score_r_withpar_count], cluster(sch_cohort)
*JR: estimates store col3
*JR: 
*JR: sum score_r_withpar [w=score_r_withpar_count] if e(sample)
*JR: local col3_individuals=`r(sum_w)'
*JR: 
*JR: * Output regressions
*JR: esttab col* using ${tab}/paper1/table3_col23_irsdate${IRSdate}_tfxdate${tfxdate}.csv, replace keep(tv) cells(b(fmt(%12.0g)) se(abs par fmt(%12.0g))) obslast
*JR: estimates clear
*JR: 
* Output number of individuals (i.e weighted N)
*file open col23 using ${tab}/paper1/table3_col23_irsdate${IRSdate}_tfxdate${tfxdate}.csv, write text append
*file write col23 "N_individuals,`col2_individuals',`col3_individuals'"
*file close col23

* Paper only: Parent characteristic bias calcs
file open biascalc using `tabdir'/paper1/paperonly_table3_bias_calcs.csv, write text replace

*qui reg diff_score_rminuspar middle math middle_math [w=diff_score_rminuspar_count]
qui reg diff_predscore_pared math [w=diff_predscore_count]
predict diff_r if e(sample), r

sum diff_r [w=diff_predscore_count]
file write biascalc "The standard deviation of class-average predicted score residuals based on parent characteristics is:" _n
file write biascalc (r(sd)) _n

reg score_r diff_r [w=diff_predscore_count], cluster(sch_cohort)
file write biascalc "The F-statistic on the parent characteristics in the regression of test score residuals on residualized parent characteristics (run at the classroom level) is:" _n
file write biascalc (e(F)) _n

*qui reg tv middle math middle_math [w=diff_score_rminuspar_count]
qui reg tv math [w=diff_predscore_count]
predict tv_r if e(sample), r

*reg diff_score_rminuspar tv middle math middle_math [w=diff_score_rminuspar_count], cluster(sch_cohort)
reg diff_predscore_pared tv math [w=diff_predscore_count], cluster(sch_cohort)
scalar __coeff=_b[tv]

corr tv_r diff_r [w=diff_predscore_count]
file write biascalc "The correlation of class-average predicted score residuals based on parent characteristics and VA estimates is:" _n
file write biascalc (r(rho)) _n
file write biascalc "If this correlation were 1 instead then the bias due to sorting on parent characteristics would be:" _n
file write biascalc (__coeff/r(rho)) _n
file close biascalc

*** Table 3, Col 4
use `cfrdat'/tfx/score_r_l2_score_notmiss, clear
*gen middle_math=middle*math
gen diff_score_l2score = score_r - score_r_l2

** Col 4
*reg diff_score_l2score tv middle math middle_math, cluster(sch_cohort)
reg diff_score_l2score tv math , cluster(sch_cohort)
estimates store col4

*esttab col* using ${tab}/paper1/table3_col4_irsdate${IRSdate}_tfxdate${tfxdate}.csv, replace keep(tv) cells(b(fmt(%12.0g)) se(abs par fmt(%12.0g))) obslast
*estimates clear
*
** Figure 2c (corresponds to Col 4)
*binscatter diff_score_l2score tv, noaddmean controls(middle math middle_math) 
binscatter diff_score_l2score tv, noaddmean controls(math ) ///
	xscale(range(-.2 0.23)) ///
	yscale(range(-.2 0.235)) ///
	legend(off) ylabel(,angle(horizontal)) ///
	title("Predicted Score using Year t-2 Score", size(medium)) ///
	xtitle("Teacher Value-Added") ///
	ytitle("Predicted Score") /// 
	ylabel(-0.2(0.1)0.2, angle(0))
multi_graph_export using `figdir'/paper1/fig2c

** Paper only: Twice lagged score bias calcs

*collapse (mean) score_r diff_score_l2score tv (count) diff_score_l2score_count=diff_score_l2score, by(sch year class_id middle math middle_math)
collapse (mean) score_r diff_score_l2score tv (count) diff_score_l2score_count=diff_score_l2score, by(sch year class_id math )

file open biascalc using `tabdir'/paper1/paperonly_table3_bias_calcs.csv, write text append
file write biascalc _n _n

*qui reg diff_score_l2score middle math middle_math [w=diff_score_l2score_count]
qui reg diff_score_l2score math [w=diff_score_l2score_count]
predict diff_r if e(sample), r

sum diff_r [w=diff_score_l2score_count]
file write biascalc "The standard deviation of class-average predicted score residuals based on twice lagged scores is:" _n
file write biascalc (r(sd)) _n

*qui reg tv middle math middle_math [w=diff_score_l2score_count]
qui reg tv math [w=diff_score_l2score_count]
predict tv_r if e(sample), r

*reg diff_score_l2score tv middle math middle_math [w=diff_score_l2score_count]
reg diff_score_l2score tv math [w=diff_score_l2score_count]
scalar __coeff=_b[tv]

corr tv_r diff_r [w=diff_score_l2score_count]
file write biascalc "The correlation of class-average predicted score residuals based on twice lagged scores and VA estimates is:" _n
file write biascalc (r(rho)) _n
file write biascalc "If this correlation were 1 instead then the bias due to sorting on twice lagged scores would be:" _n
file write biascalc (__coeff/r(rho)) _n
file close biascalc
 
 
 
*JR NOTES: The code below is new, not in CFR's program. In Fig 2 and
*JR NOTES: much of Table 3, CFR use *residual* scores, after regressing
*JR NOTES: against the VAM controls, but describe them as actual scores.
*JR NOTES: This is reported in some of the table/figure notes, but you
*JR NOTES: have to look carefully to see it. In these lines, I add code
*JR NOTES: to re-do the relevant estimates using actual scores.
use stuid sch grade year math score teacher l2_score PREZl_score using `cfrdat'/schd_work, clear
merge 1:1 stuid year math using `cfrdat'/tfx/score_r, assert(1 3) keepusing(score_r) nogen
merge 1:1 stuid year math using `cfrdat'/NOTIRS_studentlevel, assert(1 3) keepusing(predscore_pared) nogen
* Merge in tv from the _tym file so that the sample matches correctly
cap drop tv
merge m:1 teacher year math using `cfrdat'/tfx/tfx_tym.dta, assert(1 3) keep(3) nogen keepusing(tv)
g cohort=year-grade
egen sch_cohort = group(sch cohort)

*JR orig: reg score_r tv middle math middle_math, cluster(sch_cohort)
reg score tv math , cluster(sch_cohort)
estimates store altcol1
reg predscore_pared tv math , cluster(sch_cohort)
estimates store altcol2

reg score l2_score PREZl_score math
predict pscore_l2, xb
reg pscore_l2 tv math, cluster(sch_cohort)
estimates store altcol4
esttab col1 col2 col4 altcol1 altcol2 altcol4 using `tabdir'/paper1/table3_col1.csv, replace keep(tv) cells(b(fmt(%12.0g)) se(abs par fmt(%12.0g))) obslast
estimates clear
file open tab3 using `tabdir'/paper1/table3_col1.csv, write text append
file write tab3 "N_individuals,`col2_individuals'"
file close tab3

* Alternative Figure 2a (corresponds to Col 1)
binscatter score tv, noaddmean controls(math ) ///
	xscale(range(-.2 0.23)) ///
	yscale(range(-.2 0.235)) ///
	legend(off) ylabel(,angle(horizontal)) ///
	title("Actual Actual Score", size(medium)) ///
	xtitle("Teacher Value-Added") ///
	ytitle("Score in Year t") /// 
	ylabel(-0.2(0.1)0.2, angle(0))
multi_graph_export using `figdir'/paper1/fig2a_alt

* Alternative Figure 2b (corresponds to Col 2)
binscatter predscore_pared tv, noaddmean controls(math ) ///
	xscale(range(-.2 0.23)) ///
	yscale(range(-.2 0.235)) ///
	legend(off) ylabel(,angle(horizontal)) ///
	title("Actual Predicted Score using Parent Characteristics", size(medium)) ///
	xtitle("Teacher Value-Added") ///
	ytitle("Score in Year t") /// 
	ylabel(-0.2(0.1)0.2, angle(0))
multi_graph_export using `figdir'/paper1/fig2b_alt

* Alternative Figure 2c (corresponds to Col 4)
binscatter pscore_l2 tv, noaddmean controls(math ) ///
	xscale(range(-.2 0.23)) ///
	yscale(range(-.2 0.235)) ///
	legend(off) ylabel(,angle(horizontal)) ///
	title("Actual Predicted Score using Year t-2 Score", size(medium)) ///
	xtitle("Teacher Value-Added") ///
	ytitle("Predicted Score") /// 
	ylabel(-0.2(0.1)0.2, angle(0))
multi_graph_export using `figdir'/paper1/fig2c_alt

if `doasproject'==1 { 
  project, creates(`logdir'/paper1_table1_summarystats_fromoutside.txt)
  project, creates(`tabdir'/paper1/table3_col1.csv)
  project, creates(`figdir'/paper1/fig2a.gph)
  project, creates(`figdir'/paper1/fig2a_alt.gph)
  project, creates(`figdir'/paper1/fig2b.gph)
  project, creates(`figdir'/paper1/fig2b_alt.gph)
  project, creates(`figdir'/paper1/fig2c.gph)
  project, creates(`figdir'/paper1/fig2c_alt.gph)
  project, creates(`tabdir'/paper1/paperonly_table3_bias_calcs.csv)
}
 