local scratchdir "`pdir'/scratch"
local rawdat "`scratchdir'/ncdata"
local cfrdat "`scratchdir'/cfrdata"
local extras "`scratchdir'/extras"
local cfrdir "`pdir'/cfr"
local logdir `cfrdir'/logs
local figdir `cfrdir'/figs
local tabdir `cfrdir'/tabs

*Control vector for baseline value-added model (note that this excludes teacher experience)
global baseline_VAM_controls PREZ* PREO* MPREO* CL* SG* SY* female ///
	age_current lunch miss_lunch ETHN* sped limited_english repeat_grade ///
	repeat_test ///
	YEAR* GRDE*
*JR: Baseline_VAM_controls edited to omit: hon rem enrich mod foreign absences suspensions post99*  
*JR: as these don't exist in the NC extract.;

*EDITS, MARCH 23, 2015. WILDCARDS IN ABOVE DEFINITION MEAN IT IS HARD TO
*BE CONFIDENT THAT THE SAME VARLIST IS OBTAINED EVERY TIME. THIS IS THE VARLIST
*IT EVALUATES TO:
*   PREZl_score PREZl_score2 PREZl_score3 
*   PREZtesXl_sco_3 PREZtesXl_sco_5 PREZtesXl_sco_6 
*   PREZtesXl_scoa3 PREZtesXl_scoa5 PREZtesXl_scoa6 
*   PREZtesXl_scob3 PREZtesXl_scob5 PREZtesXl_scob6 
*   PREOl_other PREOl_other2 PREOl_other3 
*   PREOtesXl_oth_3 PREOtesXl_oth_5 PREOtesXl_oth_6 
*   PREOtesXl_otha3 PREOtesXl_otha5 PREOtesXl_otha6 
*   PREOtesXl_othb3 PREOtesXl_othb5 PREOtesXl_othb6 
*   MPREO MPREOPREZl_score MPREOPREZl_score2 MPREOPREZl_score3 
*   CLPZl_score CLPOl_other 
*   CLETHNethnici_0 CLETHNethnici_1 CLETHNethnici_2 CLETHNethnici_3 CLETHNethnici_4 
*   CLsped CLfemale CLage_current CLmiss_lunch CLlunch CLlimited_english 
*   CLrepeat_grade CLrepeat_test 
*   CLMPREO 
*   CLMISS_sped CLMISS_age_current CLMISS_limited_english 
*   CLMPREOPREZl_score CLMPREOPREZl_score2 CLMPREOPREZl_score3 
*   CLPZl_score2 CLPZl_score3 CLPOl_other2 CLPOl_other3 
*   CLPZmodXCLl_s_4 CLPZmodXCLl_s_5 CLPZmodXCLl_sa4 CLPZmodXCLl_sa5 
*   CLPZmodXCLl_sb4 CLPZmodXCLl_sb5 CLPOmodXCLl_o_4 CLPOmodXCLl_o_5 
*   CLPOmodXCLl_oa4 CLPOmodXCLl_oa5 CLPOmodXCLl_ob4 CLPOmodXCLl_ob5 
*   CLass_size 
*   SGPZl_score SGPOl_other SGPZl_score2 SGPZl_score3 
*   SGPOl_other2 SGPOl_other3 
*   SGPZmodXSGl_s_4 SGPZmodXSGl_s_5 SGPZmodXSGl_sa4 SGPZmodXSGl_sa5 
*   SGPZmodXSGl_sb4 SGPZmodXSGl_sb5 SGPOmodXSGl_o_4 SGPOmodXSGl_o_5 
*   SGPOmodXSGl_oa4 SGPOmodXSGl_oa5 SGPOmodXSGl_ob4 SGPOmodXSGl_ob5 
*   SYETHNethnici_0 SYETHNethnici_1 SYETHNethnici_2 SYETHNethnici_3 SYETHNethnici_4 
*   SYsped SYfemale SYage_current SYmiss_lunch SYlunch SYlimited_english 
*   SYrepeat_grade SYrepeat_test 
*   SYMPREO 
*   SYMISS_sped SYMISS_age_current SYMISS_limited_english 
*   female age_current lunch miss_lunch 
*   ETHNethnici_0 ETHNethnici_1 ETHNethnici_2 ETHNethnici_3 ETHNethnici_4 
*   sped limited_english 
*   repeat_grade repeat_test 
*   YEARyear_1997 YEARyear_1998 YEARyear_1999 YEARyear_2000 YEARyear_2001 YEARyear_2002
*   YEARyear_2003 YEARyear_2004 YEARyear_2005 YEARyear_2006 YEARyear_2007 YEARyear_2008 
*   YEARyear_2010 YEARyear_2011 
*   GRDEgrade_3 GRDEgrade_5
*NOTE THAT THIS LIST INCLUDES CL AND SY MEANS OF THE MISSING INDICATORS FOR
* SPED, AGE_CURRENT, AND LIMITED_ENGLISH, BUT NOT THE INDIVIDUAL VERSIONS.
*THE ABOVE CODE IS WHAT WAS USED IN THE 10/2014 VERSION OF MY PAPER. IN 3/2015,
*CODE MODIFIED TO BE EXPLICIT. LIST3 IS NEW IN THIS VERSION.
local list1  "female age_current lunch miss_lunch sped limited_english repeat_grade repeat_test"
local list2  "ETHNethnici_0 ETHNethnici_1 ETHNethnici_2 ETHNethnici_3 ETHNethnici_4 " 
local list3  "MISS_sped MISS_age_current MISS_limited_english"
local list4  "PREZl_score PREZl_score2 PREZl_score3 PREOl_other PREOl_other2 PREOl_other3 "
local list5  "MPREO MPREOPREZl_score MPREOPREZl_score2 MPREOPREZl_score3 "
local list6  "PREZtesXl_sco_3 PREZtesXl_sco_5 PREZtesXl_sco_6 "
local list7  "PREZtesXl_scoa3 PREZtesXl_scoa5 PREZtesXl_scoa6 "
local list8  "PREZtesXl_scob3 PREZtesXl_scob5 PREZtesXl_scob6 "
local list9  "PREOtesXl_oth_3 PREOtesXl_oth_5 PREOtesXl_oth_6 "
local list10 "PREOtesXl_otha3 PREOtesXl_otha5 PREOtesXl_otha6 "
local list11 "PREOtesXl_othb3 PREOtesXl_othb5 PREOtesXl_othb6 "
local list12 "YEARyear_1997 YEARyear_1998 YEARyear_1999 YEARyear_2000 YEARyear_2001 YEARyear_2002 "
local list13 "YEARyear_2003 YEARyear_2004 YEARyear_2005 YEARyear_2006 YEARyear_2007 YEARyear_2008 "
local list14 "YEARyear_2010 YEARyear_2011 "
local list15 "GRDEgrade_3 GRDEgrade_5 "
local list16 "CLsped CLfemale CLage_current CLmiss_lunch CLlunch CLlimited_english "
local list17 "CLrepeat_grade CLrepeat_test "
local list18 "CLMISS_sped CLMISS_age_current CLMISS_limited_english "
local list19 "CLETHNethnici_0 CLETHNethnici_1 CLETHNethnici_2 CLETHNethnici_3 CLETHNethnici_4 "
local list20 "CLPZl_score CLPOl_other "
local list21 "CLMPREO "
local list22 "CLMPREOPREZl_score CLMPREOPREZl_score2 CLMPREOPREZl_score3 "
local list23 "CLPZl_score2 CLPZl_score3 CLPOl_other2 CLPOl_other3 "
local list24 "CLPZmodXCLl_s_4 CLPZmodXCLl_s_5 CLPZmodXCLl_sa4 CLPZmodXCLl_sa5 "
local list25 "CLPZmodXCLl_sb4 CLPZmodXCLl_sb5 CLPOmodXCLl_o_4 CLPOmodXCLl_o_5 "
local list26 "CLPOmodXCLl_oa4 CLPOmodXCLl_oa5 CLPOmodXCLl_ob4 CLPOmodXCLl_ob5 "
local list27 "CLass_size "
local list28 "SYsped SYfemale SYage_current SYmiss_lunch SYlunch SYlimited_english "
local list29 "SYrepeat_grade SYrepeat_test "
local list30 "SYMISS_sped SYMISS_age_current SYMISS_limited_english "
local list31 "SYETHNethnici_0 SYETHNethnici_1 SYETHNethnici_2 SYETHNethnici_3 SYETHNethnici_4 "
local list32 "SYMPREO "
local list33 "SGPZl_score SGPOl_other "
local list34 "SGPZl_score2 SGPZl_score3 SGPOl_other2 SGPOl_other3 "
local list35 "SGPZmodXSGl_s_4 SGPZmodXSGl_s_5 SGPZmodXSGl_sa4 SGPZmodXSGl_sa5 "
local list36 "SGPZmodXSGl_sb4 SGPZmodXSGl_sb5 SGPOmodXSGl_o_4 SGPOmodXSGl_o_5 "
local list37 "SGPOmodXSGl_oa4 SGPOmodXSGl_oa5 SGPOmodXSGl_ob4 SGPOmodXSGl_ob5 "
local fulllist `"`list1'"'
forvalues n=2/37 {
	local fulllist : list fulllist | list`n'
}
global baseline_VAM_controls_orig `"$baseline_VAM_controls"'
global baseline_VAM_controls : list clean local(fulllist)

*Control vector for second-stage regression includes only class-level variables so we can 
*run on collapsed data
global controls CL* SG* SY* YEAR* GRDE*
 *EDITS MARCH 2015
  global controls_orig `"$controls"'
  local fulllistB `"`list12'"'
  forvalues n=13/37 {
  	local fulllistB : list fulllistB | list`n'
  }
  global controls : list clean local(fulllistB)
  
*JR: controls edited to remove hon-foreign ;
*We don't have these: global par_controls par_everownhome par_evermarried par_everhave401k par_age_birth par_missing par_age_missing par_inc_trim_mean parinc2 parinc3 parinc4 parincm1 parincm2 parincm3 parincm4;
global par_controls ERROR

* Load necessary ado-files
  *JR orig: adopath ++ ${root}/code/adopath                 
  *JR orig: run ${root}/code/binscatter_v5_10.ado           
  *JR orig: run ${root}/code/prepare_quasi.ado              
  *JR orig: run ${root}/code/postvam_save_l2score.ado       
  *JR orig: run ${root}/code/eventstudy_v2_2.ado            
  *JR orig: run ${root}/code/residualize_middle_math.ado    
  *JR orig: run ${root}/code/longterm_crossclass_table.ado  
  *JR orig: run ${root}/code/reshape_longterm_cc_output.ado 
  *JR orig: run ${root}/code/multi_graph_export.ado         
 foreach f in binscatter_v5_10 prepare_quasi postvam_save_l2score ///
              eventstudy_v2_2 residualize_middle_math longterm_crossclass_table ///
              reshape_longterm_cc_output multi_graph_export vam fastxtile {
    if `doasproject'==1 project, relies_on("`cfrdir'/cfrprograms/`f'.ado")
    run `cfrdir'/cfrprograms/`f'.ado
  }
 if `doasproject'==1 project, relies_on("`cfrdir'/cfrprograms/vam.sthlp")
 if `doasproject'==1 project, relies_on("`cfrdir'/cfrprograms/fastxtile.sthlp")
