*Runs after validteachers.do, and prepares sample for CFR-style analysis;
*Based closely on CFR's "create_schd_work_final.do";
* Part 2/3

version 12.1
matrix drop _all
estimates clear

cap project, doinfo
if _rc==0 {
	local doasproject=1
	local pdir "`r(pdir)'"						  	    // the project's main dir.
	local dofile "`r(dofile)'"						    // do-file's stub name
  local sig {bind:{hi:[RP : `dofile'.do]}}	// a signature in notes

}
else {
  local doasproject=0
	local pdir "~/teachereffects/cfr_replic/project"
	local dofile "prepcfrsamp"
	local sig "Not run as part of project!"
	
}

#delimit;
local scratchdir "`pdir'/scratch";
local rawdat "`scratchdir'/ncdata";
local cfrdat "`scratchdir'/cfrdata";
local extras "`scratchdir'/extras";

if `doasproject'==1 project, uses(`cfrdat'/prepcfrsamp.dta);
use `cfrdat'/prepcfrsamp, clear;

******************************NOTE!!!!!!!!**********************
**We are going to keep only a small fraction, to speed programs*;
******************************NOTE!!!!!!!!**********************;
*keep if sch<=100;

* FLAG HIGH SPEC ED CLASSES;
        g byte flag_sped= CLsped>.25 & CLsped<.;

* VARIABLE FOR SAMPLE TO USE IN ANALYSIS;
        *g byte sample_to_keep= flag_sped==0 & CLass_size>9.5;
        *keep if sample_to_keep==1;
        *CFR DROP OBS NOT IN SAMPLE. I WILL FLAG THEM, BUT KEEP ALL;
        gen byte flag_sample=(flag_sped==0 & CLass_size>9.5);

* NEW CLASS SIZE VARIABLE TO CHECK WHETHER WE GOT THE IRS DATA RIGHT BY VERIFYING WHETHER THE COUNT OF PEOPLE IN THE IRS DATA IN EACH CLASS;
* EXACTLY MATCHES THE CLASS_SIZE VARIABLE.  SO IT IS IMPORTANT TO GET IT EXACTLY RIGHT IN THE FINAL DATASET.;
        rename CLass_size orig_class_size;
        *bys class: egen CLass_size = sum(sample_to_keep);
        cap drop __000000;
        bys class: egen CLass_size = sum(flag_sample);
        replace flag_sample=0 if CLass_size<=9.5;
compress;
*Save two versions -- with and without flag sample;
 save `cfrdat'/schd_work, replace;
 keep if flag_sample~=1;
 save `cfrdat'/schd_work_nonsample, replace;
 use if flag_sample==1 using `cfrdat'/schd_work;
 save `cfrdat'/schd_work, replace;
 if `doasproject'==1 project, creates(`cfrdat'/schd_work.dta);
 if `doasproject'==1 project, creates(`cfrdat'/schd_work_nonsample.dta);
 

***************************************************************
************SAMPLE COUNTS REPORTED IN THE PAPER****************
***************************************************************;
use `cfrdat'/schd_work.dta;
*CFR have 15.7 million obs total in grades 4-8. I get 8.0m in 3-5;
count if grade>=3&grade<=5 & flag_sample==1;
*CFR have 9.1 million obs total in grades 4-8 with non-missing teacher.;
*I have 6.3m. Note that they are missing 40%+ of their sample!;
*count if grade>=3&grade<=5&teacher~=.;
count if grade>=3&grade<=5 & flag_sample==1 & teacher<900000000;
*CFR have 7.7 million obs total in grades 4-8 with non-missing teacher and score gains;
*I have 5.6m. Again, I lose fewer for missing scores (perhaps because I dropped them earlier).;
*count if grade>=3&grade<=5&teacher~=.&score~=.&PREZl_score~=.;
count if grade>=3&grade<=5 & flag_sample==1 & teacher<900000000 &score~=.&PREZl_score~=.;


