*Runs after validteachers.do, and prepares sample for CFR-style analysis;
*Based closely on CFR's "create_schd_work_final.do";
* Part 3/3

version 12.1
matrix drop _all
estimates clear

cap project, doinfo
if _rc==0 {
	local doasproject=1
	local pdir "`r(pdir)'"						  	    // the project's main dir.
	local dofile "`r(dofile)'"						    // do-file's stub name
  local sig {bind:{hi:[RP : `dofile'.do]}}	// a signature in notes

}
else {
  local doasproject=0
	local pdir "~/teachereffects/cfr_replic/project"
	local dofile "prepcfrsamp"
	local sig "Not run as part of project!"
	
}

#delimit;
local scratchdir "`pdir'/scratch";
local rawdat "`scratchdir'/ncdata";
local cfrdat "`scratchdir'/cfrdata";
local extras "`scratchdir'/extras";


 if `doasproject'==1 project, uses(`cfrdat'/schd_work.dta);
 if `doasproject'==1 project, uses(`cfrdat'/schd_work_nonsample.dta);
 


* GENERATE TEACHER-CLASS LIST and other MISC datasets used in analysis program;
**JR EDIT: DO THIS TWICE, ONCE FOR THE FULL SAMPLE (INCLUDING FLAG_SAMPLE==0)
**         AND ONCE FOR THE ESTIMATION SAMPLE;
**START WITH ESTIMATION SAMPLE;
use teacher year sch flag_sample using `cfrdat'/schd_work.dta;
/*JR orig: keep teacher*/
keep if teacher~=.;
bys teacher year: keep if _n==1; /*JR orig: bysort teacher: keep if _n==1*/
*JR orig: merge 1:m teacher using $datadir/final_teacher_list_in_schd_work_schools.dta;
*JR orig: drop if _m==2;
*JR orig: drop _m;
save `cfrdat'/final_teacher_list_linked_to_students.dta , replace;
if `doasproject'==1 project, creates(`cfrdat'/final_teacher_list_linked_to_students.dta);

use teacher class_id sch year modal_grade math flag_sample using `cfrdat'/schd_work, clear;
keep if teacher~=.;
bysort sch year class_id math: keep if _n==1;
sort sch year class_id math;
save `cfrdat'/teacher_class_list_from_schd_work5, replace;
if `doasproject'==1 project, creates(`cfrdat'/teacher_class_list_from_schd_work5.dta);

use `cfrdat'/schd_work, clear;
*Set seed for replicability;
 local state=c(seed);
 set seed 231930874;
keep if uniform()<.01;
 set seed `state';
save `cfrdat'/schd_work_1pct, replace;
if `doasproject'==1 project, creates(`cfrdat'/schd_work_1pct.dta);

use year grade math sch using `cfrdat'/schd_work, clear;
drop if sch==.|grade==.;
bys sch year grade math: g n_rpool = _N;
bys sch year grade math: keep if _n==1;
sort sch year grade math;
save `cfrdat'/sch_grade_enrollments.dta, replace;
if `doasproject'==1 project, creates(`cfrdat'/sch_grade_enrollments.dta);

use teacher year grade math using `cfrdat'/schd_work, clear;
keep if grade~=. & teacher~=.;
bys teacher year math grade: g n_students = _N;
bys teacher year math grade: keep if _n==1;
sort teacher year grade math;
save `cfrdat'/teacher_enrollments, replace;
if `doasproject'==1 project, creates(`cfrdat'/teacher_enrollments.dta);

**NOW REDO FOR FULL SAMPLE;
use teacher year sch flag_sample using `cfrdat'/schd_work_nonsample, clear;
/*JR orig: keep teacher*/
keep if teacher~=.;
bys teacher year: keep if _n==1; /*JR orig: bysort teacher: keep if _n==1*/
*JR orig: merge 1:m teacher using $datadir/final_teacher_list_in_schd_work_schools.dta;
*JR orig: drop if _m==2;
*JR orig: drop _m;
append using `cfrdat'/final_teacher_list_linked_to_students.dta;
save `cfrdat'/final_teacher_list_linked_to_students_fullsample.dta , replace;
if `doasproject'==1 project, creates(`cfrdat'/final_teacher_list_linked_to_students_fullsample.dta);

use teacher class_id sch year modal_grade math flag_sample using `cfrdat'/schd_work_nonsample, clear;
keep if teacher~=.;
bysort sch year class_id math: keep if _n==1;
append using `cfrdat'/teacher_class_list_from_schd_work5;
sort sch year class_id math;
save `cfrdat'/teacher_class_list_from_schd_work5_fullsample, replace;
if `doasproject'==1 project, creates(`cfrdat'/teacher_class_list_from_schd_work5_fullsample.dta);


use `cfrdat'/schd_work_nonsample, clear;
 local state=c(seed);
 set seed 231930874;
keep if uniform()<.01;
 set seed `state';
append using `cfrdat'/schd_work_1pct;
save `cfrdat'/schd_work_1pct_fullsample, replace;
if `doasproject'==1 project, creates(`cfrdat'/schd_work_1pct_fullsample.dta);

use year grade math sch using `cfrdat'/schd_work_nonsample, clear;
drop if sch==.|grade==.;
bys sch year grade math: g n_rpool = _N;
bys sch year grade math: keep if _n==1;
append using `cfrdat'/sch_grade_enrollments;
sort sch year grade math;
save `cfrdat'/sch_grade_enrollments_fullsample.dta, replace;
if `doasproject'==1 project, creates(`cfrdat'/sch_grade_enrollments_fullsample.dta);

use teacher year grade math using `cfrdat'/schd_work_nonsample, clear;
keep if grade~=. & teacher~=.;
bys teacher year math grade: g n_students = _N;
bys teacher year math grade: keep if _n==1;
append using `cfrdat'/teacher_enrollments;
sort teacher year grade math;
save `cfrdat'/teacher_enrollments_fullsample, replace;
if `doasproject'==1 project, creates(`cfrdat'/teacher_enrollments_fullsample.dta);

