
*apptab_altimpute.do
*By Jesse Rothstein
*7/7/15
*
*This program explores various imputations for teachers with missing VA
***********************************************************************

version 12
clear *
matrix drop _all
estimates clear
set varabbrev off /*JR added*/

cap project, doinfo
if _rc==0 {
	local doasproject=1
	local pdir "`r(pdir)'"						  	    // the project's main dir.
	local dofile "`r(dofile)'"						    // do-file's stub name
  local sig {bind:{hi:[RP : `dofile'.do]}}	// a signature in notes

}
else {
  local doasproject=0
	local pdir "~/teachereffects/cfr_replic/project"
	local dofile "apptab_altimpute"
	local sig "Not run as part of project!"
	
}
local thisdir "`pdir'/extension"
local cfrdat "`pdir'/scratch/cfrdata"

************* OTHER FILES USED *****************************
if `doasproject'==1 {
 	project, uses(`pdir'/scratch/extension/preparequasi.dta)
}


 use `pdir'/scratch/extension/preparequasi

 *Set up baseline now.
 *CFR quasiexperiment
  areg d_score_tv_CLwgt dva_tv_CLwgt [w=SGY_size_tv_CLwgt], cluster(sch_cohort) a(sch_yr)
  eststo r1_tv_m0
 *Placebo test
  areg d_score_l_tv_CLwgt dva_tv_CLwgt [w=SGY_size_tv_CLwgt], cluster(sch_cohort) a(sch_yr)
  eststo r2_tv_m0
 *Quasiexperiment with control
  areg d_score_tv_CLwgt dva_tv_CLwgt d_score_l_tv_CLwgt [w=SGY_size_tv_CLwgt], cluster(sch_cohort) a(sch_yr)
  eststo r3_tv_m0

  areg d_score_all_CL2wgt dva_all_CLwgt [w=SGY_size_all_CLwgt], cluster(sch_cohort) a(sch_yr)
  eststo r1_alt
  areg d_score_l_all_CL2wgt dva_all_CLwgt [w=SGY_size_all_CLwgt], cluster(sch_cohort) a(sch_yr)
  eststo r2_alt
  areg d_score_all_CL2wgt dva_all_CLwgt d_score_l_all_CL2wgt [w=SGY_size_all_CLwgt], cluster(sch_cohort) a(sch_yr)
  eststo r3_alt

 foreach imp in 0 miss skl sklmiss {
  areg d_score_all_CL2wgt dva_imp`imp'_CLwgt [w=SGY_size_all_CLwgt], cluster(sch_cohort) a(sch_yr)
  eststo r1_`imp'
  areg d_score_l_all_CL2wgt dva_imp`imp'_CLwgt [w=SGY_size_all_CLwgt], cluster(sch_cohort) a(sch_yr)
  eststo r2_`imp'
  areg d_score_all_CL2wgt dva_imp`imp'_CLwgt d_score_l_all_CL2wgt [w=SGY_size_all_CLwgt], cluster(sch_cohort) a(sch_yr)
  eststo r3_`imp'
 }
  
esttab r1_*, ///
   cells(b(fmt(5)) se(fmt(5))) r2 obslast nodepvars
esttab r2_*, ///
   cells(b(fmt(5)) se(fmt(5))) r2 obslast nodepvars
esttab r3_*, ///
   cells(b(fmt(5)) se(fmt(5))) r2 obslast nodepvars

esttab r1_* using `thisdir'/`dofile'.txt, replace ///
   cells(b(fmt(5)) se(fmt(5))) r2 obslast nodepvars noparentheses
esttab r2_* using `thisdir'/`dofile'.txt, append ///
   cells(b(fmt(5)) se(fmt(5))) r2 obslast nodepvars noparentheses
esttab r3_* using `thisdir'/`dofile'.txt, append ///
   cells(b(fmt(5)) se(fmt(5))) r2 obslast nodepvars noparentheses

esttab r1_* using `thisdir'/`dofile'.csv, replace ///
   cells(b(fmt(5)) se(fmt(5))) r2 obslast nodepvars 
esttab r2_* using `thisdir'/`dofile'.csv, append ///
   cells(b(fmt(5)) se(fmt(5))) r2 obslast nodepvars 
esttab r3_* using `thisdir'/`dofile'.csv, append ///
   cells(b(fmt(5)) se(fmt(5))) r2 obslast nodepvars 


 if `doasproject'==1 {
 	 project, creates(`thisdir'/`dofile'.txt)
 	 project, creates(`thisdir'/`dofile'.csv)
 }
