*Program to estimate an alternative VA model that leaves out all test variables.
*The goal here is to obtain the predicted values -- we dont need the teacher TV 
*estimates.

version 12
clear *
matrix drop _all
estimates clear
set varabbrev off /*JR added*/

cap project, doinfo
if _rc==0 {
	local doasproject=1
	local pdir "`r(pdir)'"						  	    // the project's main dir.
	local dofile "`r(dofile)'"						    // do-file's stub name
  local sig {bind:{hi:[RP : `dofile'.do]}}	// a signature in notes

}
else {
  local doasproject=0
	local pdir "~/teachereffects/cfr_replic/project"
	local dofile "demogpredict"
	local sig "Not run as part of project!"
	
}
local thisdir "`pdir'/extension"
local cfrdat "`pdir'/scratch/cfrdata"
local cfrdir "`pdir'/cfr"
if `doasproject'==1 project, relies_on("`cfrdir'/cfrprograms/vam.ado")
run `cfrdir'/cfrprograms/vam.ado


************* OTHER FILES USED *****************************
if `doasproject'==1 {
	project, uses(`cfrdat'/schd_work_trim.dta)
}


 use `cfrdat'/schd_work_trim.dta, clear
 isid stuid math year
 
 
 *** Define globals for different groups of baseline control vars
 
 local VAM_demog_ind "ETHN* sped female age_current miss_lunch lunch limited_english repeat_grade repeat_test MISS_sped MISS_age_current MISS_limited_english"
 local VAM_demog_class "CLETHN* CLsped CLfemale CLage_current CLmiss_lunch CLlunch CLlimited_english CLrepeat_grade CLrepeat_test CLMISS_* CLass_size "
 local VAM_demog_schgr "SYETHN* SYsped SYfemale SYage_current SYmiss_lunch SYlunch SYlimited_english SYrepeat_grade SYMISS_* SYrepeat_test"
 local VAM_year_grade_fe "YEAR* GRDE*"
 

 *JR Note: This is row 7 of CFR-I, Table 6 (though I don't impose the restriction
 *that test measures be non-missing)
 tempfile math reading all
 gen score_r=.
 forvalues m=0/1 {
 	 di "running regression for math==`m'"
	 areg score `VAM_demog_ind' `VAM_demog_class' `VAM_demog_schgr' `VAM_year_grade_fe' ///
	   if math==`m', absorb(teacher)
	 predict score_r`m', dresiduals
	 replace score_r=score_r`m' if math==`m'
	}
 keep stuid math year score score_r
 isid stuid math year
 sort stuid math year
 gen score_p_demog=score-score_r
 rename score_r score_r_demog
 drop score
 save `pdir'/scratch/extension/`dofile'.dta, replace
 
 if `doasproject'==1 project, creates(`pdir'/scratch/extension/`dofile'.dta)
 