
*table1.do
*By Jesse Rothstein
*7/1/2015
*
*This program estimates the basic CFR regressions, using both their
*variables and my replicates of them
***********************************************************************

version 12
clear *
matrix drop _all
estimates clear
set varabbrev off /*JR added*/

cap project, doinfo
if _rc==0 {
	local doasproject=1
	local pdir "`r(pdir)'"						  	    // the project's main dir.
	local dofile "`r(dofile)'"						    // do-file's stub name
  local sig {bind:{hi:[RP : `dofile'.do]}}	// a signature in notes

}
else {
  local doasproject=0
	local pdir "~/teachereffects/cfr_replic/project"
	local dofile "table1"
	local sig "Not run as part of project!"
	
}
local thisdir "`pdir'/extension"
local cfrdat "`pdir'/scratch/cfrdata"

************* OTHER FILES USED *****************************
if `doasproject'==1 {
 	project, uses(`pdir'/scratch/replication/basicreplication.dta)
 	project, uses(`pdir'/scratch/extension/preparequasi.dta)
}


 
*Check that CFR regressions are exactly replicated with my variables;
 *CFR regressions;
  use `pdir'/scratch/replication/basicreplication
 * Col 1
  areg d_mean_score d_tv_sgm_1 [w=SGYsize], cluster(sch_cohort) a(year)
  estimates store replic_c1A
 * Col 2
  areg d_mean_score d_tv_sgm_1 [w=SGYsize], cluster(sch_cohort) a(sch_yr)
  estimates store replic_c2A
 * Col 3
  areg d_pred_score_pared d_tv_sgm_1 [w=SGYsize], cluster(sch_cohort) a(sch_yr)
  estimates store replic_c3A
 * Col 4
  areg d_mean_score_T5 d_tv_sgm_1_T5 [w=SGYsize_T5], cluster(sch_cohort) a(year)
  estimates store replic_c4A
 *And my regressions
  use `pdir'/scratch/extension/preparequasi
 * Col 1
  areg d_score_tv_CLwgt dva_tv_CLwgt [w=SGY_size_tv_CLwgt], cluster(sch_cohort) a(year)
  estimates store replic_c1B
 * Col 2
  areg d_score_tv_CLwgt dva_tv_CLwgt [w=SGY_size_tv_CLwgt], cluster(sch_cohort) a(sch_yr)
  estimates store replic_c2B
 * Col 3
  areg d_score_p_pared_tv_CLwgt dva_tv_CLwgt [w=SGY_size_tv_CLwgt], cluster(sch_cohort) a(sch_yr)
  estimates store replic_c3B
 * Col 4
  areg d_score_all_CL2wgt dva_all_CLwgt [w=SGY_size_all_CLwgt], cluster(sch_cohort) a(year)
  estimates store replic_c4B

  
*Report results;
 *Replication; 
  esttab replic_c??, cells(b(fmt(5)) se(fmt(5))) r2 obslast nodepvars
  esttab replic_c?? using `thisdir'/`dofile'_replication.txt, replace ///
         cells(b(fmt(5)) se(fmt(5))) r2 obslast nodepvars
  esttab replic_c?? using `thisdir'/`dofile'_replication.csv, replace ///
         cells(b(fmt(5)) se(fmt(5))) r2 obslast nodepvars noparentheses
 *Main table;
  esttab replic_c?B, cells(b(fmt(5)) se(fmt(5))) r2 obslast nodepvars
  esttab replic_c?B using `thisdir'/`dofile'.txt, replace ///
         cells(b(fmt(5)) se(fmt(5))) r2 obslast nodepvars
  esttab replic_c?B using `thisdir'/`dofile'.csv, replace ///
         cells(b(fmt(5)) se(fmt(5))) r2 obslast nodepvars noparentheses
 
 if `doasproject'==1 {
 	 project, creates(`thisdir'/`dofile'.txt)
 	 project, creates(`thisdir'/`dofile'_replication.txt)
 	 project, creates(`thisdir'/`dofile'.csv)
 	 project, creates(`thisdir'/`dofile'_replication.csv)
 }
