
*table2.do
*By Jesse Rothstein
*7/1/15
*
*This program estimates the basic CFR regressions, using lagged scores
*for the dependent variable
***********************************************************************

version 12
clear *
matrix drop _all
estimates clear
set varabbrev off /*JR added*/

cap project, doinfo
if _rc==0 {
	local doasproject=1
	local pdir "`r(pdir)'"						  	    // the project's main dir.
	local dofile "`r(dofile)'"						    // do-file's stub name
  local sig {bind:{hi:[RP : `dofile'.do]}}	// a signature in notes

}
else {
  local doasproject=0
	local pdir "~/teachereffects/cfr_replic/project"
	local dofile "table2"
	local sig "Not run as part of project!"
	
}
local thisdir "`pdir'/extension"
local cfrdat "`pdir'/scratch/cfrdata"

************* OTHER FILES USED *****************************
if `doasproject'==1 {
 	project, uses(`pdir'/scratch/extension/preparequasi.dta)
}


 use `pdir'/scratch/extension/preparequasi

*Identify samples so we can hold them fixed
 * T1, Col 1
  areg d_score_tv_CLwgt dva_tv_CLwgt [w=SGY_size_tv_CLwgt], cluster(sch_cohort) a(year)
  gen samp_panelA=e(sample)
 * T1, Col 4
  areg d_score_all_CL2wgt dva_all_CLwgt [w=SGY_size_all_CLwgt], cluster(sch_cohort) a(year)
  gen samp_panelB=e(sample)


*Panel A - no imputations
 * Col 1
  areg d_score_l_tv_CLwgt dva_tv_CLwgt [w=SGY_size_tv_CLwgt] if samp_panelA==1, cluster(sch_cohort) a(sch_yr)
  estimates store pAc1
 * Col 2
  areg d_score_p_tv_CLwgt dva_tv_CLwgt [w=SGY_size_tv_CLwgt] if samp_panelA==1, cluster(sch_cohort) a(sch_yr)
  estimates store pAc2
 * Col 3.
  areg d_score_p_demog_tv_CLwgt dva_tv_CLwgt [w=SGY_size_tv_CLwgt] if samp_panelA==1, cluster(sch_cohort) a(sch_yr)
  estimates store pAc3
 
*Panel B - with imputations
 * Col 1
  areg d_score_l_all_CL2wgt dva_all_CLwgt [w=SGY_size_all_CLwgt] if samp_panelB==1, cluster(sch_cohort) a(sch_yr)
  estimates store pBc1
 * Col 2
  areg d_score_p_all_CL2wgt dva_all_CLwgt [w=SGY_size_all_CLwgt] if samp_panelB==1, cluster(sch_cohort) a(sch_yr)
  estimates store pBc2
 * Col 3.
  areg d_score_p_demog_all_CL2wgt dva_all_CLwgt [w=SGY_size_all_CLwgt] if samp_panelB==1, cluster(sch_cohort) a(sch_yr)
  estimates store pBc3

*Last regression: Table 2, column 1, panel A, but with year FEs to correspond to what CFR sent
  areg d_score_l_tv_CLwgt dva_tv_CLwgt [w=SGY_size_tv_CLwgt] if samp_panelA==1, cluster(sch_cohort) a(year)

esttab p?c?, ///
   cells(b(fmt(5)) se(fmt(5))) r2 obslast nodepvars

esttab p?c? using `thisdir'/`dofile'.txt, replace ///
   cells(b(fmt(5)) se(fmt(5))) r2 obslast nodepvars
esttab p?c? using `thisdir'/`dofile'.csv, replace ///
   cells(b(fmt(5)) se(fmt(5))) r2 obslast nodepvars noparentheses

 
 if `doasproject'==1 {
 	 project, creates(`thisdir'/`dofile'.txt)
 	 project, creates(`thisdir'/`dofile'.csv)
 }
