version 12.1
matrix drop _all
estimates clear

cap project, doinfo
if _rc==0 {
	global doasproject=1
	local pdir "`r(pdir)'"						  	    // the project's main dir.
	local dofile "`r(dofile)'"						    // do-file's stub name
  local sig {bind:{hi:[RP : `dofile'.do]}}	// a signature in notes

}
else {
  global doasproject=0
	local pdir "~/teachereffects/cfr_replic/project"
	local dofile "prepdata_SAR"
	local sig "Not run as part of project!"
	
}

#delimit;
global rawpers "~/data/nceduc/statafmt/Classroom/Personnel";
local scratchdir "`pdir'/scratch";
local outdir="`scratchdir'/ncdata";
global scratch "`scratchdir'";
set varabbrev off;
set more off;

local fyear=1995;
local lyear=2011;

cap program drop readpers;
program define readpers;
  args year;
  
  if $doasproject==1 project, original("${rawpers}/pers`year'.dta.gz");
	! zcat ${rawpers}/pers`year'.dta.gz > ${scratch}/pers`year'.dta;
 
  use ${scratch}/pers`year'.dta;

  ! rm ${scratch}/pers`year'.dta;

  *Temporary -- we are just stacking one district for cleaning;
*   keep if lea=="250";

  cap destring semstr, replace;
  
  gen year=`year';
  
end;

forvalues y=`fyear'/`lyear'{;
			di "Reading year=`y' data";
      readpers `y';
      tempfile pers`y';
      save `pers`y'';
};

local first=1;
forvalues y=`fyear'/`lyear' {;
			di "Appending year=`y' data";
  		if `first'==1 use `pers`y'';
	  	else append using `pers`y'';
		  local first=0;
};

*Identify self-contained elementary classes:
* Academic level = standard
* Assignment = teacher
* Subjct = 0000
;

 gen teachassign=(astype=="TE");
 gen byte teachassign_alt=inlist(astype, "TE", "TT", "CT");
 gen stdlevel=(acadlvl=="2");
 gen selfcont=(subjct=="0000");
 gen grade3=(sccgrd=="3");
 gen grade4=(sccgrd=="4");
 gen grade5=(sccgrd=="5");
 
 keep lea year schlcode semstr teachassign stdlevel selfcont subjct teachid grade3 grade4 grade5 sccgrd teachassign_alt;
compress;
save `outdir'/prepdata_SAR, replace;
if $doasproject==1 project, creates(`outdir'/prepdata_SAR.dta);  