*Read in student end-of-grade files. Go through 6th grade to get some forward scores.;
*(We will only use 3-5 later, since those can be most reliably matched to teachers.);

*base_fixedN.do

version 12.1
matrix drop _all
estimates clear

cap project, doinfo
if _rc==0 {
	local doasproject=1
	local pdir "`r(pdir)'"						  	    // the project's main dir.
	local dofile "`r(dofile)'"						    // do-file's stub name
  local sig {bind:{hi:[RP : `dofile'.do]}}	// a signature in notes

}
else {
  local doasproject=0
	local pdir "~/teachereffects/cfr_replic/project"
	local dofile "prepdata_students"
	local sig "Not run as part of project!"
	
}

#delimit;
local raweogA "~/data/nceduc/statafmt/Student/End of Grade";
local raweogB "~/data/nceduc/statafmt/Student/End\ of\ Grade";
local scratchdir "`pdir'/scratch";
local outdir="`scratchdir'/ncdata";
set varabbrev off;
set more off;

local fyear=1995;
local lyear=2011;

cap program drop readeog;
program define readeog;
  args year grade raweogA raweogB scratch doasproject;
  if `year'>=2010 local yy=`year'-2000;
  else if `year'>=2000 {;
    local yy=`year'-2000;
    local yy "0`yy'";
  };
  else local yy=`year'-1900;
 
  if `year'<1995 {;
  	 if `doasproject'==1 project, original("`raweogA'/`year'/eog`grade'pub`year'.dta.gz");
  	 ! zcat `raweogB'/`year'/eog`grade'pub`year'.dta.gz > `scratch'/eog`grade'pub`yy'.dta;
  };
  else if `year'==2001 & `grade'==4 {;
  	 if `doasproject'==1 project, original("`raweogA'/`year'/eog`grade'pub`yy'r.dta.gz");
  	 ! zcat `raweogB'/`year'/eog`grade'pub`yy'r.dta.gz > `scratch'/eog`grade'pub`yy'.dta;
  };	
  else {;
  	 if `doasproject'==1 project, original("`raweogA'/`year'/eog`grade'pub`yy'.dta.gz");
  	 ! zcat `raweogB'/`year'/eog`grade'pub`yy'.dta.gz > `scratch'/eog`grade'pub`yy'.dta;
di "Got to here";
  };
  
  use `scratch'/eog`grade'pub`yy'.dta;
  ! rm `scratch'/eog`grade'pub`yy'.dta;

  *Temporary -- we are just stacking one district for cleaning;
   *keep if lea=="250";

  *Some original file variables;
   gen byte test_grade=`grade';
   cap confirm var year;
   if _rc~=0 gen year=`year';
  
  *Drop a bunch of variables that we don't use that create trouble in appending;
   capture drop chap1*;
   cap destring mathpc, replace;
   cap destring readpc, replace;
  
  *Start with cleaning;
   *Grade;
    cap replace grade="00" if grade=="PK" | grade=="K" | grade=="KG";
    cap destring grade, replace force;
    if _rc==0 gen student_grade=grade;

    if `year'<=2009 destring except, replace;   
   
end;

forvalues y=`fyear'/`lyear'{;
	forvalues g=3/6 {;
		if `y'==1996 & inlist(`g',5,6) {;
			di "No G5 or G6 data in 1996";
		};
		else {;
			di "Reading year=`y', grade=`g' data";
      readeog `y' `g' "`raweogA'" "`raweogB'" "`scratchdir'" `doasproject';
      tempfile eog`y'`g';
      save `eog`y'`g'';
    };
  };
};

local first=1;
forvalues y=`fyear'/`lyear' {;
	forvalues g=3/6 {;
		if `y'==1996 & inlist(`g',5,6) {;
			di "No G5 or G6 data in 1996";
		};
		else {;
			di "Appending year=`y', grade=`g' data";
  		if `first'==1 use `eog`y'`g'';
	  	else append using `eog`y'`g'';
		  local first=0;
		};
  };
};

*Now clean the data;
   *Special;
    *Need to check codes here.  Codes changed between 1998-9 and 1999/0, I think, then again between 2001-2 and 2002-3;
    *Include 
    *Codes in 1995 (same in 1999). Codebooks say 2000 is different, but it looks the same:
      * 1 = Not identified as an Exceptional Student
      * 2 = Academically/Intellectually Gifted (AIG)
      * 3 = Behaviorally-Emotionally Handicapped
      * 4 = Hearing Impaired
      * 5 = Educable Mentally Handicapped
      * 6 = Specific Learning Disabled
      * 7 = Speech-Language Impaired
      * 8 = Visually Impaired
      * 9 = Other Health Impaired
      *10 = Orthopedically Impaired
      *11 = Traumatic Brain Injured
      *12 = Other Exceptional Classifications
    *In 2001, codes 1-11 are the same.  Rest are:
      *12 = Autistic
      *13 = Severe/Profound Mentally Disabled
      *14 = Multihandicapped
      *15 = Deaf-Blind
      *16 = Trainable Mentally Handicapped
    *In 2003, order changed:
       * 7 = Visually Impaired
       * 8 = Other Health Impaired	
       * 9 = Orthopedically Impaired
       *10 = Traumatic Brain Injured
       *11 = Severe/Profound Mentally Disabled 
       *12 = Multihandicapped
       *13 = Speech-Language Impaired
       *14 = Trainable Mentally Handicapped
       *15 = Specific Leaning Disabled
       *16 = Autistic;
    *It is supposed to exist through 2009, but is missing in 2009;
    ;
    gen byte special=inlist(except, 3,4,5,6,7,8,9,11,12) if year<=2000;
    replace special=inlist(except, 3,4,5,6,7,8,9,11,12,13,14,15,16) if year<=2002;
    replace special=inlist(except, 3,4,5,6,7,8,10,11,12,13,14,15,16) if year<2009 ;
    label var special "Special ed";
   *Lunch:  1=free,2=reduced,0=none;
    gen byte lunch=1*(schlunch=="2")+2*(schlunch=="1") if inlist(schlunch, "0", "1", "2")
      & year>=1999 & year<=2002;
    replace lunch=1*(schlunch=="2") + 2*(schlunch=="3") if inlist(schlunch, "2","3","4")
      & year>=2003 & year<=2005;
    replace lunch=(frl=="F") + 2*(frl=="R") if inlist(frl, "F", "N", "R") 
      & year==2006;
    gen byte miss_lunch=(lunch==.);    	
    replace lunch=0 if miss_lunch==1;
   *Limited English;
    gen byte limited_english=(inlist(limeng, "1", "Y")) if year<=2002;
    replace  limited_english=(inlist(lep, "1", "2")) if year==2003;
    replace  limited_english=(inlist(lepstat, "2", "3", "4", "5")) if year==2004 | year==2005;
    replace  limited_english=(lep_current=="1") if year==2006 ;
    replace  limited_english=(inlist(lepstat, "1", "2")) if year>=2007 & year<=2009 ;
    *Whatever the codebook says, we dont have a limited english variable in 2007 or 2009;
     tab year limited_english, m;
     replace limited_english=. if year==2009 | year==2007;
   *Female;
    gen byte female=(sex=="F");
   *Ethnicity;
    gen byte ethnicity=1*(ethnic=="B") + 2*(ethnic=="H") + 3*(ethnic=="A") + 4*(ethnic=="I") + 5*(ethnic=="W");
    label define eth_l 1 "Bl" 2 "Hi" 3 "As" 4 "In" 5 "Wh" 0 "M/O";
    label values ethnicity eth_l;
   *Parent education -- codes change in early 2000s;
    destring pared, replace;
    replace pared=pared+1 if (year<2000 | inlist(year, 2001, 2002)) & pared>2;
    *Two of the codes (trade school and CC) seem to switch in 2003 and 2004, though
    *the codebook isn't entirely clear about this (later footnotes say there was
    *a switch, but it seems to have been temporary.;
    replace pared=9-pared if inlist(year, 2003, 2004) & inlist(pared, 4, 5);
    label define pared_l 1 "LTHS" 2 "HSD" 3 "Scol" 4 "Trade" 5 "CC" 6 "4yr" 7 "MA+";
    label values pared pared_l;

   local vlist "test_grade student_grade year mastid mathscal readscal teachid lea schlcode";
   local vlist2 "special lunch miss_lunch limited_english female ethnicity";
   local vlist3 "bdate daysabs pared administ";
   keep `vlist' `vlist2' `vlist3';

   *Now that we've cleaned all our variables, need to make sure that we have unique IDs. 
    *Unfortunately, there are duplicate observations in many cases.
    *No good way to resolve them. First, drop duplicates on all vars.
    *Then, if we still have duplicates, drop the whole bunch.;
    
   *Student ID;
    drop if mastid==.;
   *Keep only if there is just one observation per student-year;
    *Drop duplicates for all observations;
     duplicates drop;
    *In 2009-2011, there are a lot of students listed with separate
    *records for separate administrations. we will keep the first one;
     sort mastid year administ;
     by mastid year: keep if administ==administ[1];
    *If, after that, we wind up with multiple observations, drop all of them.;
     duplicates tag mastid year, gen(dup);
    tab dup;
    tab year test_grade if dup~=0, m;
    drop if dup~=0;
    drop dup;
/*
   *Keep only one observation per student-year-grade;
    destring administ, replace force;
    replace administ=0 if year<=2000;
    assert administ<3 if !missing(administ);
    replace administ=10 if administ==.;
    sort mastid year test_grade administ;
    *First, we drop anyone in a subsequent administration -- 
    *       note that the sort order is not unique here, but thats OK;
    by mastid year test_grade: drop if administ>administ[1];
    sort mastid year test_grade readscal mathscal;
    *Again, not necessarily a unique sort order, but here we drop
    * anyone with multiple observations showing different scores.;
    by mastid year test_grade: drop if readscal[_N]~=readscal[1] | mathscal[_N]~=mathscal[1];
    *Now we have multiple observations with the same scores, same administration.;
    *    within mastid-year-test_grade cells. ;
    duplicates report mastid year test_grade;
    *Theres no good way to resolve these. Drop duplicates on all vars,
    *then drop any non-unique obs.;
     duplicates drop;
     duplicates tag mastid year test_grade, gen(dup);
     tab dup;
     drop if dup~=0;
     drop dup;
    by mastid year: keep if _N==1;
*/

   *Standardize scores;
    sort year test_grade mastid;
    replace readscal=. if readscal==0;
    by year test_grade: egen avgread=mean(readscal);
    by year test_grade: egen sdread=sd(readscal);
    gen readstd=(readscal-avgread)/sdread;
    drop avgread sdread;
    *table year test_grade, contents(mean readscal sd readscal min readscal max readscal);
    replace mathscal=. if mathscal==0;
    by year test_grade: egen avgmath=mean(mathscal);
    by year test_grade: egen sdmath=sd(mathscal);
    gen mathstd=(mathscal-avgmath)/sdmath;
    drop avgmath sdmath;
    *table year test_grade, contents(mean mathscal sd mathscal min mathscal max mathscal);
    
    
compress;   
save `outdir'/prepdata_students.dta, replace;
if `doasproject'==1 project, creates(`outdir'/prepdata_students.dta);

  